import sys
import pandas as pd
import pdfkit
from xlsx2html import xlsx2html
import os

def remove_trailing_empty_rows(df):
    last_valid_index = df.apply(lambda row: row.notna().any(), axis=1).iloc[::-1].idxmax()
    return df.loc[:last_valid_index]

excel_path = sys.argv[1]
output_pdf_path = sys.argv[2]

df = pd.read_excel(excel_path)
trimmed_df = remove_trailing_empty_rows(df)

cleaned_excel = excel_path.replace(".xlsx", "_trimmed.xlsx")
html_path = excel_path.replace(".xlsx", ".html")

trimmed_df.to_excel(cleaned_excel, index=False)

with open(html_path, "w", encoding="utf-8") as html_file:
    xlsx2html(cleaned_excel, html_file)

pdfkit.from_file(html_path, output_pdf_path)

os.remove(cleaned_excel)
os.remove(html_path)
